VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "The Hook Example"
   ClientHeight    =   2190
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4050
   LinkTopic       =   "frmMain"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   2190
   ScaleWidth      =   4050
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pctIconBuffer 
      AutoRedraw      =   -1  'True
      Height          =   255
      Left            =   2550
      ScaleHeight     =   195
      ScaleWidth      =   285
      TabIndex        =   5
      Top             =   2280
      Visible         =   0   'False
      Width           =   345
   End
   Begin VB.PictureBox pctIcon 
      AutoRedraw      =   -1  'True
      Height          =   960
      Left            =   90
      ScaleHeight     =   900
      ScaleWidth      =   1215
      TabIndex        =   4
      Top             =   1140
      Width           =   1280
   End
   Begin VB.ListBox lstLog 
      Height          =   2010
      Left            =   1460
      TabIndex        =   3
      Top             =   90
      Width           =   2505
   End
   Begin VB.PictureBox pctMousePosBuffer 
      AutoRedraw      =   -1  'True
      Height          =   255
      Left            =   2160
      ScaleHeight     =   195
      ScaleWidth      =   285
      TabIndex        =   2
      Top             =   2280
      Visible         =   0   'False
      Width           =   345
   End
   Begin VB.PictureBox pctMousePos 
      AutoRedraw      =   -1  'True
      Height          =   960
      Left            =   90
      ScaleHeight     =   900
      ScaleWidth      =   1215
      TabIndex        =   1
      Top             =   90
      Width           =   1280
   End
   Begin VB.PictureBox pctHook 
      Height          =   165
      Left            =   1890
      ScaleHeight     =   105
      ScaleWidth      =   135
      TabIndex        =   0
      Top             =   2280
      Visible         =   0   'False
      Width           =   195
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Settings for hook DLL.
Private Declare Sub SetValuesKey Lib "TheHook.dll" (ByVal hWnd As Long, _
        ByVal hHook As Long)
Private Declare Sub SetValuesMouse Lib "TheHook.dll" (ByVal hWnd As _
        Long, ByVal hHook As Long)

'Get key info, used to receive a log of key strokes (since this app
'     can't properly see shifted keystrokes, we let the hook dll
'     calculate a keystroke)
'NOTE: szChars should be a byte array of 50 elements
Private Declare Sub GetKeyInfo Lib "TheHook.dll" (szChars As Any, _
        nLastPos As Long)

'This function gets a copy of the last cursor used.  This is useful
'     since GetCursor won't return the cursor of another app.
'NOTE: We must delete the returned cursor.
Private Declare Function GetLastCursor Lib "TheHook.dll" () As Long

' Windows API
Private Declare Function SetWindowsHookEx Lib "user32" Alias _
        "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, _
        ByVal hMod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook _
        As Long) As Long
Private Declare Function LoadLibrary Lib "kernel32" Alias _
        "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule _
        As Long, ByVal lpProcName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule _
        As Long) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, _
        ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long
Private Declare Function DestroyCursor Lib "user32" (ByVal hCursor _
        As Long) As Long
Private Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, _
        ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As _
        Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal _
        istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, _
        ByVal diFlags As Long) As Long

Private Const WH_KEYBOARD = 2
Private Const WH_MOUSE = 7

' Variables required for hook
Private m_hHookKey As Long
Private m_hHookMouse As Long
Private m_hMod As Long

Private Sub Form_Load()
    
    Dim lpProcKey As Long  'This is the hook for the keyboard
    Dim lpProcMouse As Long 'And the mouse
    
    'Attempt to load the library, bail out if it fails
    m_hMod = LoadLibrary(App.Path & "\TheHook.dll")
    If m_hMod = 0 Then
        MsgBox "Unable to load dll!"
        End
    End If
    
    'Attempt to find the two hook procedures, bail out
    ' if either one is not found
    lpProcKey = GetProcAddress(m_hMod, "KeyProc")
    lpProcMouse = GetProcAddress(m_hMod, "MouseProc")
    If lpProcKey = 0 Or lpProcMouse = 0 Then
        MsgBox "Unable to find entry point!"
        End
    End If
    
    ' Call the API to start the hook
    m_hHookKey = SetWindowsHookEx(WH_KEYBOARD, lpProcKey, m_hMod, 0)
    m_hHookMouse = SetWindowsHookEx(WH_MOUSE, lpProcMouse, m_hMod, 0)
    
    ' Make sure the DLL knows about all the necessary values
    SetValuesKey pctHook.hWnd, m_hHookKey
    SetValuesMouse pctHook.hWnd, m_hHookMouse
    
    SetupUI 'Setup all the UI Elements
    
End Sub

Private Sub SetupUI()
    
    ' Hide the picture box, since we're only intrested in
    '  messages that come as a result of the hook
    pctHook.Visible = False
    
    ' Setup the buffer for the mouse posisiton box
    pctMousePosBuffer.Height = pctMousePos.Height
    pctMousePosBuffer.Width = pctMousePos.Width
    
    ' Setup the buffer for the current moues cursor
    pctIconBuffer.Width = pctIcon.Width
    pctIconBuffer.Height = pctIcon.Height
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    'Unload the system hooks and our DLL
    
    UnhookWindowsHookEx m_hHookKey
    UnhookWindowsHookEx m_hHookMouse
    
    FreeLibrary m_hMod
    
End Sub

Private Sub pctHook_KeyPress(KeyAscii As Integer)
    'Since the picture box is hidden, this is a result of the keyboard
    ' hook.  Ignore KeyAscii, and call the DLL to find out what the
    ' keystroke was , since the shift state will be wrong if we're in
    ' another application's queue
    
    Static nLastPos As Long
    Static nNewPos As Long
    Static szChars(0 To 49) As Byte
    Static i As Long
    
    GetKeyInfo szChars(0), nNewPos
    
    If nNewPos = nLastPos Then
        Exit Sub
    End If
    
    If nNewPos < nLastPos Then
        nNewPos = nNewPos + 50
    End If
    
    For i = nLastPos To nNewPos - 1
        
        'Just send the result to the listbox
        AddToLogList "Keystroke - [ " & Chr(szChars(i Mod 50)) & " ]"
        
    Next
    
    nLastPos = nNewPos Mod 50
    
End Sub

Private Sub pctHook_MouseDown(Button As Integer, Shift As Integer, x As _
        Single, y As Single)

    AddToLogList "MouseDown - " & Format(Button) & " - " & Format(x / _
                 Screen.TwipsPerPixelX) & "/" & Format(y / _
                 Screen.TwipsPerPixelY)

End Sub

Private Sub pctHook_MouseMove(Button As Integer, Shift As Integer, x As _
        Single, y As Single)

    'Draw the mouse position in the top picturebox
    pctMousePosBuffer.Cls

    pctMousePosBuffer.Line ((x / Screen.Width) * pctMousePos.ScaleWidth _
                           - Screen.TwipsPerPixelX, (y / Screen.Height) _
                           * pctMousePos.ScaleHeight - _
                           Screen.TwipsPerPixelY)-Step(Screen.TwipsPerPixelX _
                           * 3, Screen.TwipsPerPixelY * 3), , BF

    pctMousePos.Picture = pctMousePosBuffer.Image

    'If the mouse cursor has changed, draw it's image in
    ' the second picturebox
    Dim hCursor As Long
    hCursor = GetLastCursor()
    If hCursor <> 0 Then
        pctIconBuffer.Cls
        'DrawIcon pctIconBuffer.hdc, 3, 0, hCursor
        DrawIconEx pctIconBuffer.hdc, 5, 5, hCursor, 0, 0, 1, False, 3
        pctIcon.Picture = pctIconBuffer.Image
        DestroyCursor hCursor
    End If

End Sub

Private Sub pctHook_MouseUp(Button As Integer, Shift As Integer, x As _
        Single, y As Single)

    AddToLogList "MouseUp - " & Format(Button) & " - " & Format(x / _
                 Screen.TwipsPerPixelX) & "/" & Format(y / _
                 Screen.TwipsPerPixelY)

End Sub

Private Sub AddToLogList(sToAdd As String)
    'This function just adds the string to our listbox
    
    'Make sure there aren't more items than can be displayed without a
    '   scrollbar (including the one I'm about to add)
    Do While (lstLog.ListCount + 1) * Me.TextHeight("A") > _
          lstLog.Height And lstLog.ListCount > 0
        lstLog.RemoveItem 0
    Loop
    
    lstLog.AddItem sToAdd
    
End Sub

